<template>
    <div>
        <label
            v-if="!hideLabel"
            class="block text-sm font-medium capitalize"
            :class="{
                'border-red-500': errors && errors.length,
                'text-red-500': errors && errors.length,
                'font-black': boldLabel,
            }"
        >
            {{ label || name }}
        </label>
        <div
            class="mt-1 relative"
        >
            <datepicker
                v-model="data"
                :flow="flow"
                :text-input-options="textInputOptions"
                :model-type="dateFormat"
                :preview-format="dateFormat"
                :format="dateFormat"
                text-input
                :clearable="false"
                auto-apply
                close-on-auto-apply
                :enable-time-picker="false"
                :month-change-on-arrows="false"
                :month-change-on-scroll="false"
                :input-class-name="customInputClass"
                :disabled="disabled"
                :readonly="readonly"
                :class="{
                    'form-control': true,
                    'disabled': readonly || disabled,
                }"
            />
        </div>
        <div
            v-if="note && Array.isArray(note)"
        >
            <div
                v-for="(n, i) in note"
                :key="`note-${i}`"
            >
                <div class="font-light font-sm">{{ n }}</div>
            </div>
        </div>
        <div
            v-else-if="note && !Array.isArray(note)"
        >
            <div class="font-light font-sm">{{ note }}</div>
        </div>
        <div
            v-if="errors && errors.length"
        >
            <div
                v-for="(err, i) in errors"
                :key="i"
            >
                <div class="font-light font-sm text-red-500">{{ err }}</div>
            </div>
        </div>
    </div>
</template>

<script setup>
import {ref, watch, computed} from 'vue';
const props = defineProps({
    name: {
        required: true,
        type: [String, Number],
    },
    label: {
        required: false,
        type: [String, Number],
        default: null,
    },
    boldLabel: {
        required: false,
        type: Boolean,
        default: false,
    },
    hideLabel: {
        required: false,
        type: Boolean,
        default: false,
    },
    placeholder: {
        required: false,
        type: [String, Number, Boolean],
        default: '',
    },
    note: {
        required: false,
        type: [String, Number, Array],
        default: null,
    },
    modelValue: {
        required: false,
        type: [String, Number, Boolean],
        default: '',
    },
    errors: {
        required: false,
        type: Array,
        default: () => [],
    },
    disabled: {
        required: false,
        type: Boolean,
        default: false,
    },
    readonly: {
        required: false,
        type: Boolean,
        default: false,
    }
});

let data = ref(props.modelValue);
const emit = defineEmits(['update:modelValue']);

const dateFormat = 'yyyy-MM-dd';

const flow = ref(['month', 'year', 'calendar']);
const textInputOptions = ref({
    format: dateFormat,
});

const customInputClass = computed(() => {
    let arr = [];

    arr.push('focus:ring-indigo-500 focus:border-indigo-500 block w-full sm:text-sm border rounded-md p-2 text-black');

    if (!props.errors) arr.push('border-gray-300');
    if (props.errors && props.errors.length) {
        arr.push('border-red-500');
        arr.push('text-red-500');
    }

    if (props.disabled || props.readonly) arr.push('opacity-50');

    if (arr && arr.length) {
        return arr.join(' ');
    } else {
        return '';
    }
})

watch(data, (newValue) => {
    emit('update:modelValue', newValue);
});
</script>
